#include <iostream>
#include <cstdio>
#include <cstring>
#include <string>
#include <vector>
#include <queue>
#include <algorithm>
#include <cmath>

using namespace std;

#define INF 1000010
int m[30];
char strr[100010];
int str[100010];
int dp[100010][30];
int len;

void init(){
    int i, j;
    char cc = 'a';
    len = strlen(strr);
    for(i = 0; i <= 26; i ++){
        m[i] = 100;
        for(j = 0; j <= len; j ++)
            dp[j][i] = INF;
    }
    for(i = 1; i <= len; i ++){
        str[i] = strr[i - 1] - 'a';
    }
}

int main(){
    int k;
    int i, j;
    while(~scanf("%s", strr)){
        init();
        scanf("%d", &k);
        getchar();
        for(i = 1; i <= k; i ++){
            char cc1 = getchar();
            char cc2 = getchar();
            getchar();
            int c1 = cc1 - 'a' ;
            int c2 = cc2 - 'a' ;
            m[c1] = c2;
            m[c2] = c1;
        }
        dp[0][26] = 0;
        for(i = 1; i <= len; i ++){
            for(j = 0; j <= 26; j ++)
            if(dp[i - 1][j] != INF){
                //maxm = max(maxm, dp[i - 1][i - j]);
                dp[i][j] = min(dp[i][j], dp[i - 1][j] + 1);
                if(m[str[i]] != j){
                    dp[i][str[i]] = min(dp[i][str[i]], dp[i - 1][j]);
                }
            }
        }
        int ans = INF;
        for(i = 0; i < 26; i ++){
            //printf("%d\n", dp[len - 1][i]);
            ans = min(ans, dp[len][i]);
        }
        printf("%d\n", ans);
    }
    return 0;
}